Bug 865194 - non-portable dtrace/libtool build usage
non-portable dtrace/libtool build usage
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: glib2 (Show other bugs)
17
x86_64 Linux
unspecified Severity low
: ---
: ---
Assigned To: Matthias Clasen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-10 20:59 EDT by Claudio Saavedra
Modified: 2013-08-01 00:25 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 663289
Environment:
Last Closed: 2013-08-01 00:25:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Claudio Saavedra 2012-10-10 20:59:13 EDT
+++ This bug was initially created as a clone of Bug #663289 +++

+++ This bug was initially created as a clone of Bug #651328 +++

Description of problem:

trying to rpmbuild --rebuild glib-2.27.3 src.rpm from koji to address bug 651328.

Found build process calls dtrace" from systemtap to generate object file, then, do non-standard linking with libtool:

================
dtrace -G -s glib_probes.d -o glib_probes.o
...
/bin/sh ../libtool  --tag=CC   --mode=link gcc  -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m32 -
march=i686 -mtune=atom -fasynchronous-unwind-tables -Wl,-Bsymbolic-functions  -version-info 2704:0:2704 -export-dynamic  -export-symbols-regex "^g.*" -m32 -o libglib-2.0.la -rpath /usr/lib garray.lo gasyncqueue.lo gatomic-gcc.lo gbacktrace.lo gbase64.lo gbitlock.lo gbookmarkfile.lo gbuffer.lo gcache.lo gchecksum.lo gcompletion.lo gconvert.lo gdataset.lo gdate.lo gdatetime.lo gdir.lo gerror.lo gfileutils.lo ghash.lo ghook.lo ghostutils.lo giochannel.lo gkeyfile.lo glist.lo gmain.lo gmappedfile.lo gmarkup.lo gmem.lo gmessages.lo gnode.lo goption.lo gpattern.lo gpoll.lo gprimes.lo gqsort.lo gqueue.lo grel.lo grand.lo gregex.lo gscanner.lo gsequence.lo gshell.lo gslice.lo gslist.lo gstdio.lo gstrfuncs.lo gstring.lo gtestutils.lo gthread.lo gthreadpool.lo gtimer.lo gtimezone.lo gtree.lo guniprop.lo gutf8.lo g
unibreak.lo gunicollate.lo gunidecomp.lo gurifuncs.lo gutils.lo gvariant.lo gvariant-core.lo gvariant-parser.lo gvariant-serialiser.lo gvarianttypeinfo.lo gvarianttype.lo gprintf.lo libcharset/libcharset.la  giounix.lo gspawn.lo    pcre/libpcre.la -lrt glib_probes.o 
*** Warning: Linking the shared library libglib-2.0.la against the non-libtool
*** objects  glib_probes.o is not portable!
====================

This works alright on straight "rpmbuild --rebuild" but fails with "rpmbuild --target=i686 --rebuild" (from an x86_64 host) . But without being about to do the latter, it is less useful on biarch systems.

This problem can be worked around by manually editing /usr/bin/trace , towards the end, around the line :
      call(["gcc", "-fPIC"] ....
to 
      call(["gcc", "-m32", "-fPIC"] ....
but obviously this is not an ideal solution.

Either glib2 should use libtool properly all the way, or systemtap/dtrace should honour LDFLAGS/CFLAGS/FFLAGS (or whatever mechanisms to add "-m32" for building on multiarch systems).

--- Additional comment from scox@redhat.com on 2011-05-05 13:54:35 EDT ---

commit: b1568fd85e Dtrace script should honor $CPP, $CC, $CFLAGS

--- Additional comment from endoflife@fedoraproject.org on 2012-08-16 18:40:16 EDT ---

This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 1 Fedora End Of Life 2013-07-03 20:34:16 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 2 Fedora End Of Life 2013-08-01 00:25:16 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.